// This file was generated by gir (https://github.com/gtk-rs/gir)
// from
// from gir-files (https://github.com/gtk-rs/gir-files.git)
// DO NOT EDIT

use glib::{
    prelude::*,
    signal::{connect_raw, SignalHandlerId},
    translate::*,
};
use std::{boxed::Box as Box_, fmt, mem::transmute};

glib::wrapper! {
    #[doc(alias = "DzlMultiPaned")]
    pub struct MultiPaned(Object<ffi::DzlMultiPaned, ffi::DzlMultiPanedClass>) @extends gtk::Container, gtk::Widget, @implements gtk::Buildable, gtk::Orientable;

    match fn {
        type_ => || ffi::dzl_multi_paned_get_type(),
    }
}

impl MultiPaned {
    pub const NONE: Option<&'static MultiPaned> = None;

    #[doc(alias = "dzl_multi_paned_new")]
    pub fn new() -> MultiPaned {
        assert_initialized_main_thread!();
        unsafe { gtk::Widget::from_glib_none(ffi::dzl_multi_paned_new()).unsafe_cast() }
    }
}

impl Default for MultiPaned {
    fn default() -> Self {
        Self::new()
    }
}

mod sealed {
    pub trait Sealed {}
    impl<T: super::IsA<super::MultiPaned>> Sealed for T {}
}

pub trait MultiPanedExt: IsA<MultiPaned> + sealed::Sealed + 'static {
    #[cfg(feature = "v3_28")]
    #[cfg_attr(docsrs, doc(cfg(feature = "v3_28")))]
    #[doc(alias = "dzl_multi_paned_get_at_point")]
    #[doc(alias = "get_at_point")]
    fn at_point(&self, x: i32, y: i32) -> Option<gtk::Widget> {
        unsafe {
            from_glib_none(ffi::dzl_multi_paned_get_at_point(
                self.as_ref().to_glib_none().0,
                x,
                y,
            ))
        }
    }

    #[doc(alias = "dzl_multi_paned_get_n_children")]
    #[doc(alias = "get_n_children")]
    fn n_children(&self) -> u32 {
        unsafe { ffi::dzl_multi_paned_get_n_children(self.as_ref().to_glib_none().0) }
    }

    #[doc(alias = "dzl_multi_paned_get_nth_child")]
    #[doc(alias = "get_nth_child")]
    fn nth_child(&self, nth: u32) -> Option<gtk::Widget> {
        unsafe {
            from_glib_none(ffi::dzl_multi_paned_get_nth_child(
                self.as_ref().to_glib_none().0,
                nth,
            ))
        }
    }

    #[doc(alias = "resize-drag-begin")]
    fn connect_resize_drag_begin<F: Fn(&Self, &gtk::Widget) + 'static>(
        &self,
        f: F,
    ) -> SignalHandlerId {
        unsafe extern "C" fn resize_drag_begin_trampoline<
            P: IsA<MultiPaned>,
            F: Fn(&P, &gtk::Widget) + 'static,
        >(
            this: *mut ffi::DzlMultiPaned,
            object: *mut gtk::ffi::GtkWidget,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(
                MultiPaned::from_glib_borrow(this).unsafe_cast_ref(),
                &from_glib_borrow(object),
            )
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"resize-drag-begin\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    resize_drag_begin_trampoline::<Self, F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }

    #[doc(alias = "resize-drag-end")]
    fn connect_resize_drag_end<F: Fn(&Self, &gtk::Widget) + 'static>(
        &self,
        f: F,
    ) -> SignalHandlerId {
        unsafe extern "C" fn resize_drag_end_trampoline<
            P: IsA<MultiPaned>,
            F: Fn(&P, &gtk::Widget) + 'static,
        >(
            this: *mut ffi::DzlMultiPaned,
            object: *mut gtk::ffi::GtkWidget,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(
                MultiPaned::from_glib_borrow(this).unsafe_cast_ref(),
                &from_glib_borrow(object),
            )
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"resize-drag-end\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    resize_drag_end_trampoline::<Self, F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }
}

impl<O: IsA<MultiPaned>> MultiPanedExt for O {}

impl fmt::Display for MultiPaned {
    fn fmt(&self, f: &mut fmt::Formatter) -> fmt::Result {
        f.write_str("MultiPaned")
    }
}
